/*******************************************************************/
/*                                                                 */
/*   COMMON header file for IP-VLBI (K5/VSSP) utilities            */
/*          chead.h                                                */
/*                                                                 */
/*      Version:  1.01  2005-09-27                                 */
/*                                                                 */
/*******************************************************************/
#ifndef _IP_CHEAD_
#define _IP_CHEAD_

#include <stdio.h>
#include <signal.h> 
#include <errno.h>
#include <fcntl.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#ifdef linux
#include <sys/time.h>
#endif

#ifndef WIN32
#include <unistd.h>
#endif

#ifdef linux
#ifdef _K5_USE_FOPEN64_
#define fopen(_Z,_X) fopen64(_Z,_X)
#endif
#endif

//#include "libipvlbi.h"
//#include "libsked.h"

/*  graphic display set */
#ifndef PGDISP
 #define PGDISP "PGDISP"    // PGPLOT display device environment
#endif
/*  graphic display device default set */
#ifndef PGDISP_DFLT
 #ifdef WIN32
  #define PGDISP_DFLT "/GW"      
 #else
  #define PGDISP_DFLT "/XTERM"
 #endif
#endif

//#ifndef PGDISP
//#ifdef WIN32
//#define PGDISP "/GW"
//#else
//#define PGDISP "/XTERM"
//#endif
//#endif

/* constant set */

#ifndef FILEMAXSIZE
#define FILEMAXSIZE  2000000000   //  File maximum limit size in bytes when limiting
#endif

#ifndef PIRA
#define PIRA   0.017453292519943295769236907684886    /* PI/180  degree to radian */
#endif
#ifndef PIDE
#define PIDE   57.295779513082320876798154814105      /* 180/PI radian to degree  */
#endif
#ifndef TWOPI
#define TWOPI  6.283185307179586476925286766559       /* 2PI                      */
#endif
#ifndef PI
#define PI     3.1415926535897932384626433832795      /* PI                       */
#endif
#ifndef HALFPI
#define HALFPI 1.5707963267948966192313216916398      /*  PI/2                    */
#endif
#ifndef VLIGHT
#define VLIGHT 2.99792458E+8    /* speed of light (m/sec)  */
#endif

/* mainly used in libapri etc */
#ifndef CONVA
#define CONVA 4.8481368110953599358991410235795e-6    /* PI/(3600*180)  arcsec to radian */
#endif
#ifndef CONVS
#define CONVS 7.2722052166430399038487115353692e-5    /* PI/(3600*12) time sec to radian */
#endif
#ifndef CONVD
#define CONVD 0.017453292519943295769236907684886    //*PI/180  degree to radian  */
#endif
#ifndef CONVH
#define CONVH 0.26179938779914943653855361527329    /* PI/12 hour to radian  */
#endif

/* schedule file elements set */

#ifndef MAXSTAR
#define MAXSTAR 1500            // Maximum star numbers in schedule file
#endif

#ifndef MAXOBS
#define MAXOBS 2000            // Maximum observation (scan) numbers in schedule file
#endif

#ifndef MAXSTAT
#define MAXSTAT 30            // Maximum station numbers in schedule file
#endif

/* for WIN32 */

#ifdef WIN32
#ifndef _FORWIN32SET_
#define _FORWIN32SET_
typedef unsigned int    u_int32_t;
typedef _int64 int64_t;
#define popen(_Z,_X) _popen(_Z,_X)
#endif
#endif



#endif
