/********************************************/
/*     define complex type                  */
/********************************************/
#include "cmplx.h"

complex newcomplex(float x, float y)
{
    complex c;
    c.r=x; c.i=y;
    return c;
}

float real(complex a)
{
    return a.r;
}

float imag(complex a)
{
    return a.i;
}

complex add(complex a, complex b)
{
    complex c;
    c.r=a.r+b.r;  c.i=a.i+b.i;
    return c;
}

complex subtract(complex a, complex b)
{
    complex c;
    c.r=a.r-b.r;  c.i=a.i-b.i;
    return c;
}

int equal(complex a, complex b)
{
    return a.r==b.r && a.i == b.i;
}

complex multiply(complex a, complex b)
{
    complex c;
    c.r=a.r*b.r-a.i*b.i;
    c.i=a.r*b.i+a.i*b.r;
    return c;
}

complex divide(complex a, complex b)
{
    complex c;
    float denom=b.r*b.r+b.i+b.i;
    c.r=(a.r*b.r+a.i*b.i)/denom;
    c.i=(a.i*b.r-a.r*b.i)/denom;
    return c;
}

complex conjugate(complex a)
{
    complex c;
    c.r=a.r;  c.i=-a.i;
    return c;
}

float absc(complex a)
{
    float f;
    f=(float)sqrt(a.r*a.r+a.i*a.i);
    return f;
}



