/*******************************************************************/
/*                                                                 */
/*   ho|ukahpCN[ht@C libipvlbi.h              */
/*          Tv[{[hANZXȊO                           */
/*                                                                 */
/*      Version:    2005-06-10                                     */
/*                                                                 */
/*      Copyright (c) 2002-2005 T.Kondo/NICT All Right Reserved    */
/*                                                                 */
/*******************************************************************/
/*                                   
 ho|ukahpwb_[t@C  
      Tv[{[hANZXȊO   
           by T.Kondo 2001.8.26      
                      2002.5.26      
                      2002.7.06      
                      2003.6.16   hostget added
                      2003.10.12  definition of sampling frequency higher than
                                  or equal to 32MHz was added in "headerchkn"
                                  and "parsebit32n"
                      2005.6.10   divided into *.h and *.c
*/

#ifndef _LIBIPVLBI_
#define _LIBIPVLBI_

#include "chead.h"  // common header 

#ifndef WIN32
#ifdef linux
  #include <sys/vfs.h>
#else
  #include <sys/param.h>
  #include <sys/mount.h>
#endif
#endif


#ifdef WIN32
//define gettimeofday to keep source code compatibility with linux/FreeBSD 
#ifndef _WINSOCKAPI_    /* to avoid duplicate include (winsock.h also include */
                        /*    struct timeval definition */
struct timeval {          
        long    tv_sec;         /* seconds */
        long    tv_usec;        /* and microseconds */
};
#endif
struct timezone {
        int    tz_minuteswest; /* minutes W of Greenwich */
        int    tz_dsttime;     /* type of dst correction */
};
int gettimeofday(struct timeval *tv, struct timezone *tz);
#endif

typedef struct timeval_k5    // time related variables used in k5 utilities
{
    int year;      // 4 digit year
    int ddd;       // day of year
    int hh;        // hour
    int mm;        // minute
    int ss;        // sec in minute
    int second;    // sec in day
    double dtime;  // time in day (ddd+second/86400.0)
    int month;     // month
    int mday;      // day of month
} timeval_k5_t;


int cmnd_get(int argc, char *argv[], char *command, char *param);
char *select_env_dflt(char *env, char *dflt);
void parse_dir_and_name_fm_fpath(char *fpath, char *dir, char *fname); 
int getenv_from_path(char *path, char *env, int nth);
int substitute_env_path_name(char *path, char *fpath);
void get_true_path(char *path, char *dfltenv, char *dfltdir2, char *fpath);


void hostget(char* hostname); // host name get using system command
long int nint(double x);
void read1line(char *line);
void sec2hms(long int sec, int* hh, int* mm, int* ss);
int leaf_year_check(int year);   // N̂΂O^[
void ddd2md(int year, int ddd, int* month, int* mday);
void md2ddd(int year, int* ddd, int month, int mday);
void timecorrect(int* year, int* month, int* mday,
                int* hh, int* mm, int* ss, int* secadd);
void parsebit32n(unsigned char* bit32, int* spatn, 
				int* smplbit, int* sfreq, int* numch,
				long int* seconds);
void headerchkn(unsigned char* bit64, int* iok, int* spatn, int* smplbit,
			   int* sfreq, int* numch, long int* seconds, int* hh,
			   int* mm, int* ss);
void headerchkn_old(unsigned char* bit64, int* iok, int* spatn, int* smplbit,
			   int* sfreq, int* numch, long int* seconds, int* hh,
			   int* mm, int* ss);
void parseADdata(u_int32_t *ia, int numb, int adbit, int *xdata, int *npos);
void parseADdata_2(unsigned char *ia, int numb, int adbit, int *xdata, int *npos);
void parseADdata_3(unsigned char *ia, int numb, int adbit, int *xdata, int *npos);
void tk_sleep(int msec);  // suspend msec 

// following 2 functions uses "timeval" structure that is available only
//     on FreeBSD or linux.  So emulation is included in chead.h for WIN32
// 
void sec2ymds(struct timeval *tv, int *year, int* month, int* mday, int* hh, int* mm, int* ss);
void getsystimef(int* year, int* month, int* mday, int* hh, int* mm, int* ss, 
                      float *fsec, float *tofset);

// following function returns valid value only in case of linux/FreeBSD
// fixed value is returned for WIN32 just to emulate the program on Win32
double GetFreeInfo(char* dirnam);

void tmval_set(int *itime, timeval_k5_t *t);
void tmval_update_second(timeval_k5_t *t);  // convert t.seconds to time val
void tmval_update_md2ddd(timeval_k5_t *t);
void tmval_update_ddd2md(timeval_k5_t *t);

#endif
