/********************************************************************/
/*                                                                  */
/*   Program Name :  sampling2                                      */
/*                                                                  */
/*      Version:  0.00  2002-05-26                                  */
/*                1.00  2002-10-04                                  */
/*                1.01  2005-06-12                                  */
/*                                                                  */
/*      Copyright (c) 2002-2005 T.Kondo/NICT All Right Reserved     */
/*                                                                  */
/********************************************************************/
/*

 ho|ukah ItCTvOvO
        iZbg͕ʂ̃\tgōs)
         by T.Kondo 2001.8.17
                    2002.5.26
                    2002.9.15  PbƂ̃f[^ǉ
                    2002.10.04  Ver 1.0 release
                    2005.06.12  minor change
                    
    点 sampling2 span sfreq adbit numch [filename [tempdir [mode]]] 
          span   Wԁibj
                sfreq  TvOg
                       40,100,200,500  (kHz)
                       1,2,4,8,16      (MHz)
                adbit  `c\irbg)
                       1,2,4,8 
                numch  `l
                       1 ܂ 4
                filename -- f[^t@C
                      ftHgtds.data
                tempdir -- Pbf[^t@CfBNg
                      ftHg̓JgfBg
                mode    -- t@Co̓[h
                       1: ꊇt@Ĉ iftHgj
                       2: Pbf[^t@Ĉ
                       3:  ꊇt@C{Pbƃt@C
                       4:  Pbf[^t@CóAϑꊇt@C쐬
                       6: Pbf[^t@Ĉ (Ԑj
                       7: UƓit@Co͖jVXe`FbNp
*/
#include "chead.h"      // common header for IP-VLBI utilities

//#include "libipvlbi.h"  // IP-VLBIp֐Q(by T.Kondo)
//#include "libipvlbi_board.h"  // IP-VLBITv[{[hp֐Q(by T.Kondo)
/* 2005-06-12 */
#include "libipvlbi.c"  // IP-VLBIp֐Q(by T.Kondo)
#include "libipvlbi_board.c"  // IP-VLBITv[{[hp֐Q(by T.Kondo)



int main(int argc, char **argv)
{
    char outfile[80];
    char* dflt_fname="tds.data";
    char* dflt_tempdir="./";
    char outdir[60];
    int i,rv, mode;
    int span, sfreq, adbit, numch;

    if(argc < 3){
          printf("Sampling2 Ver 1.01 (c) 2005 T.Kondo/NICT\n");
          printf("Usage: sampling2 span sfreq adbit numch [filename [tempdir [mode]]]\n");
          printf("\n");
          printf("         where  span ---- duration (sec)\n");
          printf("                sfreq ---- sampling frequency\n");
          printf("                           40,100,200,500 (for kHz)\n");
          printf("                           1,2,4,8,16 (for MHz)\n");
          printf("                adbit ---- A/D bit\n");
          printf("                           1,2,4,8\n");
          printf("                          default is 1\n");
          printf("                numch ---- number of channel\n");
          printf("                           1,4\n");
          printf("                          default is 1\n");
          printf("                filename ---- out file name\n");
          printf("                          default is tds.data\n");
          printf("                tempdir ---- every 1sec data out directory\n");
          printf("                          default is current directory\n");
          printf("                mode  ---- File out mode\n");
          printf("                          1: One big file only (default)\n");
          printf("                          2: Every 1 sec file only\n");
          printf("                          3: One big file + Every 1 sec file (simultaneously)\n");
          printf("                          4: Every 1 sec file, after Obs one big file created\n");
          printf("                          5: 3 + 4 for debug purpose (debug.dat will be created)\n");
          printf("                          6: Every 1 sec file out only but no time limitation");
          printf("                              (continuous running with ring file buffer (max 10 files)\n");
          printf("                          7: same as 6 but no file out (performance check purpose)\n");
          exit(0);
    }

    span = atoi(*(argv + 1 ));
    sfreq= atoi(*(argv + 2 ));
    if (argc>=4) {
        adbit = atoi(*(argv + 3 ));
    } else {
        adbit=1;
    }

    if (argc>=5) {
        numch = atoi(*(argv + 4 ));
    } else {
        numch=1;
    }

    if (argc>=6) {
        strcpy(outfile,*(argv+5));
    } else {
        strcpy(outfile,dflt_fname);
    }
    
    if (argc>=7){
        strcpy(outdir,*(argv+6));
    } else {
        strcpy(outdir,dflt_tempdir);
    }
    /* check out dir name accompanied by "/" or not */
    i=strlen(outdir);
    //printf("i= %d\n",i);
    if(outdir[i-1] != '/') {
        outdir[i]='/';
        outdir[i+1]='\0';
    }
    
    if (argc>=8) {
        mode = atoi(*(argv + 7 ));
    } else {
        mode=1;
    }

    printf(" span    = %d\n",span);    // debug
    printf(" sfreq   = %d\n",sfreq);   // debug
    printf(" adbit   = %d\n",adbit);   // debug
    printf(" numch   = %d\n",numch);   // debug
    printf(" outfile = %s\n",outfile);   // debug

    //rv=sampleget(outfile, span, sfreq, adbit, numch);
    //rv=sampleget2(outfile, span, sfreq, adbit, numch, outdir, mode);
//  rv=sampleget3(outfile, span, sfreq, adbit, numch, outdir, mode);
    rv=sampleget4(outfile, span, sfreq, adbit, numch, outdir, mode);

    if(mode==1 || mode==3 || mode==4) {
       printf("Data File is %s\n",outfile);
    }
    if(mode==2 || mode==3 || mode==4) {
       printf("1sec Data out directory is %s\n",outdir);
    }
    

    return 0;
}
