/*********************************************************************/
/*                                                                   */
/*   Program Name :  signalcheck                                     */
/*                                                                   */
/*      Version:  0.00  2002-10-04                                   */
/*                0.10  2002-10-04                                   */
/*                1.13  2005-09-28   support linux2                  */
/*                                                                   */
/*      Copyright (c) 2002-2005  T.Kondo/NICT All Right Reserved     */
/*                                                                   */
/*********************************************************************/
/*
/*
     Signal check program 
        gp@  signalcheck

               IP-VLBI{[hɓK؂ȃx10MHz,1PPS
               ڑĂ邩ǂ̃`FbNs

*/
#include "chead.h"      // common header for IP-VLBI utilities
#ifdef linux
  #include <stdint.h>  // necessary for handling uint32_t etc.
  #include <sys/ioctl.h>
  #include <linux/tdsio.h>
#else 
  #include <sys/tdsio.h>  // IP-VLBI board header
#endif

int main(int argc, char **argv)
{
    char dev[] = "/dev/tds0";  // IP-VLBI BOARD control variable
    int fd_in,rv;
    unsigned int stat;
    
    printf("\n  K5/VSSP (IP-VLBI) board 10MHz and 1PPS signal checking..\n\n");

    fd_in = open(dev, O_RDONLY);  //foCX̃I[v
    if (fd_in == -1) {
        perror("device open() error ");
        return -1;
    }
    //printf("         Device open successd No.[%d]\n",fd_in);
    
       /* board status check */
    rv = ioctl(fd_in, TDSIO_GET_STATUS, &stat);
    if (rv == -1) {
        perror("   ioctl() status get failed ");
        goto end;
    }
    else {
              /* satatus get again just in case */
           rv = ioctl(fd_in, TDSIO_GET_STATUS, &stat);
           if (rv == -1) {
            perror("   ioctl() status get failed ");
            goto end;
           }
           //printf("ioctl() status get succeed\n");
             // printf(" status = %X\n",stat);
              if((stat & 1) != 1){
                  printf("   Warning! 10MHz signal is not supplied. \n");
              } else {
                  printf("   10MHz signal is OK!\n");
              }
              if((stat & 2) != 2){
                  printf("   Warning! 1PPS signal is not supplied. \n");
              } else {
                  printf("   1PPS  signal is OK!\n");
              }
              if((stat & 3) != 3){
                  printf("   Check signal connection and try again!\n");
                  goto end;
              }
    }
end:
    printf("\n");
    close(fd_in);

}
